#include "gioptr.h"



// GridIOLibrary global object

GridIOLibrary gridio;



// ==================================================================

GridIOLibrary::GridIOLibrary()

{

  int iResult;



  hLib = NULL;

  bLibPresent = LoadGridIOLibrary();

  m_bInitialized = false;

  return;



  if (bLibPresent)

  {

    iResult = GridIOSetup();

    m_bInitialized = true;

  }

}



// ==================================================================

GridIOLibrary::~GridIOLibrary()

{

  bool bResult = false;



  if (bLibPresent)

  {

    int iResult =0;

    if (m_bInitialized)

    {

      iResult = GridIOExit();

      m_bInitialized = false;

    }

    bResult = this->UnloadGridIOLibrary();

  }

}



// ==================================================================

bool GridIOLibrary::isLibPresent()

{

  return bLibPresent;

}



// =================================================================

//check to see if the library is initialized, if not call GridIOSetup

bool GridIOLibrary::Initialize()

{

  if (m_bInitialized)

    return m_bInitialized;

  int iRes = GridIOSetup();

  m_bInitialized = true;

  return m_bInitialized;

}



// =================================================================

bool GridIOLibrary::Release()

{

  if (m_bInitialized)

  {

    int iRes = GridIOExit();

    m_bInitialized = false;

  }

  return m_bInitialized;

}





// ==================================================================

bool GridIOLibrary::UnloadGridIOLibrary()

{

  bool bResult = false;



#ifdef __GARPWIN

  if (hLib)

    bResult = (FreeLibrary(hLib) != 0);

#endif



  return bResult;

}



// ==================================================================

bool GridIOLibrary::LoadGridIOLibrary()

{

  hLib = NULL;



#ifdef __GARPWIN



#ifdef __GRIDIO



  hLib = LoadLibrary("avgridio.dll");



  if (!hLib)

    hLib = LoadLibrary("aigridio.dll");



#endif //__GRIDIO



  if (hLib)

  {

    GridIOSetup = (TFPGridIOSetup) GetProcAddress(hLib, "GridIOSetup");

    GridIOExit = (TFPGridIOExit) GetProcAddress(hLib, "GridIOExit");

    GridExists = (TFPGridExists) GetProcAddress(hLib, "GridExists");

    GridCopy = (TFPGridCopy) GetProcAddress(hLib, "GridCopy");

    GridRename = (TFPGridRename) GetProcAddress(hLib, "GridRename");

    GridDelete = (TFPGridDelete) GetProcAddress(hLib, "GridDelete");

    GridKill = (TFPGridKill) GetProcAddress(hLib, "GridKill");

    DescribeGridDbl = (TFPDescribeGridDbl) GetProcAddress(hLib, "DescribeGridDbl");

    BndCellRead = (TFPBndCellRead) GetProcAddress(hLib, "BndCellRead");

    CellLyrExists = (TFPCellLyrExists) GetProcAddress(hLib, "CellLyrExists");

    CellLayerCreate = (TFPCellLayerCreate) GetProcAddress(hLib, "CellLayerCreate");

    CellLayerCreateTiled = (TFPCellLayerCreateTiled) GetProcAddress(hLib, "CellLayerCreateTiled");

    CellLayerOpen = (TFPCellLayerOpen) GetProcAddress(hLib, "CellLayerOpen");

    CellLyrClose = (TFPCellLyrClose) GetProcAddress(hLib, "CellLyrClose");

    CellLyrCloseNoVat = (TFPCellLyrCloseNoVat) GetProcAddress(hLib, "CellLyrCloseNoVat");

    CellLyrDelete = (TFPCellLyrDelete) GetProcAddress(hLib, "CellLyrDelete");

    CellLyrGetIO = (TFPCellLyrGetIO) GetProcAddress(hLib, "CellLyrGetIO");

    CellLyrSetIO = (TFPCellLyrSetIO) GetProcAddress(hLib, "CellLyrSetIO");

    CellLyrName = (TFPCellLyrName) GetProcAddress(hLib, "CellLyrName");

    CellLyrItem = (TFPCellLyrItem) GetProcAddress(hLib, "CellLyrItem");

    CellLyrEvalType = (TFPCellLyrEvalType) GetProcAddress(hLib, "CellLyrEvalType");

    CellLyrBlockSize = (TFPCellLyrBlockSize) GetProcAddress(hLib, "CellLyrBlockSize");

    CellLyrSta = (TFPCellLyrSta) GetProcAddress(hLib, "CellLyrSta");

    AccessWindowSet = (TFPAccessWindowSet) GetProcAddress(hLib, "AccessWindowSet");

    WindowRows = (TFPWindowRows) GetProcAddress(hLib, "WindowRows");

    WindowCols = (TFPWindowCols) GetProcAddress(hLib, "WindowCols");

    WindowBox = (TFPWindowBox) GetProcAddress(hLib, "WindowBox");

    XY2WindowColRow = (TFPXY2WindowColRow) GetProcAddress(hLib, "XY2WindowColRow");

    AccessWindowClear = (TFPAccessWindowClear) GetProcAddress(hLib, "AccessWindowClear");

    PrivateAccessWindowSet = (TFPPrivateAccessWindowSet) GetProcAddress(hLib, "PrivateAccessWindowSet");

    PrivateWindowCols = (TFPPrivateWindowCols) GetProcAddress(hLib, "PrivateWindowCols");

    PrivateWindowRows = (TFPPrivateWindowRows) GetProcAddress(hLib, "PrivateWindowRows");

    PrivateWindowBox = (TFPPrivateWindowBox) GetProcAddress(hLib, "PrivateWindowBox");

    XY2PrivateWindowColRow = (TFPXY2PrivateWindowColRow) GetProcAddress(hLib, "XY2PrivateWindowColRow");

    PrivateAccessWindowClear = (TFPPrivateAccessWindowClear) GetProcAddress(hLib, "PrivateAccessWindowClear");

    CAllocate1 = (TFPCAllocate1) GetProcAddress(hLib, "CAllocate1");

    CAllocate2 = (TFPCAllocate2) GetProcAddress(hLib, "CAllocate2");

    CAllocate3 = (TFPCAllocate3) GetProcAddress(hLib, "CAllocate3");

    CFree1 = (TFPCFree1) GetProcAddress(hLib, "CFree1");

    CFree2 = (TFPCFree2) GetProcAddress(hLib, "CFree2");

    CFree3 = (TFPCFree3) GetProcAddress(hLib, "CFree3");

    GetWindowRow = (TFPGetWindowRow) GetProcAddress(hLib, "GetWindowRow");

    GetWindowRowFloat = (TFPGetWindowRowFloat) GetProcAddress(hLib, "GetWindowRowFloat");

    GetWindowRowInt = (TFPGetWindowRowInt) GetProcAddress(hLib, "GetWindowRowInt");

    PutWindowRow = (TFPPutWindowRow) GetProcAddress(hLib, "PutWindowRow");

    GetWindowBand = (TFPGetWindowBand) GetProcAddress(hLib, "GetWindowBand");

    GetWindowBandFloat = (TFPGetWindowBandFloat) GetProcAddress(hLib, "GetWindowBandFloat");

    GetWindowBandInt = (TFPGetWindowBandInt) GetProcAddress(hLib, "GetWindowBandInt");

    PutWindowBand = (TFPPutWindowBand) GetProcAddress(hLib, "PutWindowBand");

    GetWindowRectangle = (TFPGetWindowRectangle) GetProcAddress(hLib, "GetWindowRectangle");

    GetWindowRectangleInt = (TFPGetWindowRectangleInt) GetProcAddress(hLib, "GetWindowRectangleInt");

    GetWindowRectangleFloat = (TFPGetWindowRectangleFloat) GetProcAddress(hLib, "GetWindowRectangleFloat");

    PutWindowRectangle = (TFPPutWindowRectangle) GetProcAddress(hLib, "PutWindowRectangle");

    GetWindowCell = (TFPGetWindowCell) GetProcAddress(hLib, "GetWindowCell");

    GetWindowCellFloat  = (TFPGetWindowCellFloat) GetProcAddress(hLib, "GetWindowCellFloat");

    GetWindowCellInt = (TFPGetWindowCellInt) GetProcAddress(hLib, "GetWindowCellInt");

    PutWindowCellFloat = (TFPPutWindowCellFloat) GetProcAddress(hLib, "PutWindowCellFloat");

    PutWindowCellInt = (TFPPutWindowCellInt) GetProcAddress(hLib, "PutWindowCellInt");

    PutWindowCell = (TFPPutWindowCell) GetProcAddress(hLib, "PutWindowCell");

    StaGetDbl = (TFPStaGetDbl) GetProcAddress(hLib, "StaGetDbl");

    StaGetMinmaxDbl = (TFPStaGetMinmaxDbl) GetProcAddress(hLib, "StaGetMinmaxDbl");

    GetMissingFloat = (TFPGetMissingFloat) GetProcAddress(hLib, "GetMissingFloat");





    return

      GridIOSetup && GridIOExit && GridExists && GridCopy && GridRename &&

      GridDelete && GridKill && DescribeGridDbl && BndCellRead && CellLyrExists &&

      CellLayerCreate && CellLayerCreateTiled && CellLayerOpen && CellLyrClose &&

      CellLyrCloseNoVat && CellLyrDelete && CellLyrGetIO && CellLyrSetIO &&

      CellLyrName && CellLyrItem && CellLyrEvalType && CellLyrBlockSize &&

      CellLyrSta && AccessWindowSet && WindowRows && WindowCols && WindowBox &&

      XY2WindowColRow && AccessWindowClear && PrivateAccessWindowSet &&

      PrivateWindowCols && PrivateWindowRows && PrivateWindowBox &&

      XY2PrivateWindowColRow && PrivateAccessWindowClear &&

      //CAllocate1 && CAllocate2 && CAllocate3 && CFree1 && CFree2 && CFree3 &&

      GetWindowRow && GetWindowRowFloat && GetWindowRowInt && PutWindowRow &&

      GetWindowBand && GetWindowBandFloat && GetWindowBandInt && PutWindowBand &&

      GetWindowRectangle && GetWindowRectangleInt && GetWindowRectangleFloat &&

      PutWindowRectangle && GetWindowCell && GetWindowCellFloat &&

      GetWindowCellInt && PutWindowCellFloat && PutWindowCellInt &&

      PutWindowCell && StaGetDbl && StaGetMinmaxDbl && GetMissingFloat;

  }

  else

#endif //__GARPWIN

    return false;

}



// ==================================================================

