/*
** Copyright (c) 2006 by Monash University.
** See Nimrodo_License in top-level directory.
**
*/

package org.monash.griddles;

import javax.xml.rpc.Stub;
import java.rmi.RemoteException;

import au.edu.monash.csse.nimrod.Nimrod;
import au.edu.monash.csse.nimrod.NimrodExperiment;
import au.edu.monash.csse.nimrod.Nimrod_Stub;
import au.edu.monash.csse.nimrod.NimrodParameter;
import au.edu.monash.csse.nimrod.NimrodJobInfo;
import au.edu.monash.csse.nimrod.NimrodResult;
import au.edu.monash.csse.nimrod.NimrodParameterRange;
import au.edu.monash.csse.nimrod.NimrodService_Impl;
import au.edu.monash.csse.nimrod.NimrodRunResult;

public class NimrodClient
  {
  static String args0 = null;
  public String addNimrodG(String expname)
    {
    Nimrod_Stub stub = (Nimrod_Stub) (new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    try
      {
      String[] p = new String[2];
      p[0] = "x";	
      p[1] = "y";	
      String e = nimrod.addNimrodGExperiment(expname, p, "task main\nnode:execute /bin/echo $x $y > output\nnode:execute /bin/uname -a >> output\ncopy node:output output.$x.$y\nendtask\n", "");
      return e;
      }
    catch ( RemoteException e)
      {
      return "RemoteException:"+e.getMessage();
      }
    catch ( Exception e)
      {
      return "Exception:"+e.getMessage();
      }
    }
  public NimrodExperiment getExperiment(String username, String expname)
    {
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    try
      {
      NimrodExperiment experiment = nimrod.getExperiment(username, expname);
      return experiment;
      }
    catch ( RemoteException e)
      {
      System.out.println("RemoteException:");
      System.out.println(e.getMessage());
      return null;
      }
    catch ( Exception e)
      {
      System.out.println("Exception:");
      System.out.println(e.getMessage());
      return null;
      }
    }
  public NimrodExperiment[] getExperiments(String username)
    {
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    try
      {
      NimrodExperiment[] experiments = nimrod.getExperiments(username);
      return experiments;
      }
    catch ( RemoteException e)
      {
      System.out.println("RemoteException:");
      System.out.println(e.getMessage());
      return null;
      }
    catch ( Exception e)
      {
      System.out.println("Exception:");
      System.out.println(e.getMessage());
      return null;
      }
    }
  public NimrodJobInfo getJobInfo(String username, String args) throws Exception
    {
    args = args.substring(11);
    String[] arg = args.split(" ");
    NimrodParameter[] parameters = null;
    if(arg.length != 2)
      {
      int size = arg.length / 2;
      parameters = new NimrodParameter[size];
      for (int x = 0; x < size; x++)
	{
	parameters[x] = new NimrodParameter();
	parameters[x].parameter = arg[x*2+1];
	parameters[x].value = arg[x*2+2];
	}
      }
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    NimrodJobInfo nji = null;
    if(arg.length != 2)
      {
      nji = nimrod.getJobInfo(username, arg[0], parameters);
      }
    else
      {
      nji = nimrod.getJobInfo(username, arg[0], arg[1]);
      }
    return nji;
    }
  public NimrodJobInfo addCommand(String args) throws Exception
    {          
    String[] arg = args.split(" ");
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    NimrodJobInfo ji = nimrod.addCommand(arg[1], args.substring(arg[0].length() + arg[1].length() + 2));
    return ji;
    }
  public NimrodResult addJob(String username, String args) throws Exception
    {
    args = args.substring(7);
    String[] arg = args.split(" ");
    int size = arg.length / 2;
    NimrodParameter[] parameters = new NimrodParameter[size];
    for (int x = 0; x < size; x++)
      {
      parameters[x] = new NimrodParameter();
      parameters[x].parameter = arg[x*2+1];
      parameters[x].value = arg[x*2+2];
      }
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    NimrodResult nr = nimrod.addJob(username, arg[0], parameters);
    return nr; 	
    }
  public String addSweep(String username, String args) throws Exception
    {
    args = args.substring(9);
    String[] arg = args.split(" ");
    int size = arg.length / 4;
    NimrodParameterRange[] parameters = new NimrodParameterRange[size];
    for (int x = 0; x < size; x++)
      {
      parameters[x] = new NimrodParameterRange();
      parameters[x].parameter = arg[x*4+1];
      parameters[x].value1 = arg[x*4+2];
      parameters[x].value2 = arg[x*4+3];
      parameters[x].type = "int";
      parameters[x].step = arg[x*4+4];
      }
    Nimrod_Stub stub = (Nimrod_Stub)(new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    String exptname = nimrod.addSweep(username, arg[0], parameters);
    return exptname;
    }
  public NimrodRunResult blockCommand(String username, String command) throws Exception
    {
    command = command.substring(13);
    Nimrod_Stub stub = (Nimrod_Stub) (new NimrodService_Impl().getNimrodPort());
    stub._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, args0);
    Nimrod nimrod = (Nimrod)stub;
    NimrodRunResult nr = nimrod.blockCommand(username, command);
    return nr;
    }
  }